import requests, time, re
from bs4 import BeautifulSoup
from datetime import datetime, timedelta

domain = ["sportsbay.org"]
site_name = "SportsBay"
short_id = "SB"
user_agent = "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/90.0.4430.93 Safari/537.36"

def get_games():
    games = []
    current_date = datetime.now()
    i = 1
    while (len(games) == 0 or (games[-1]["time"] - timedelta(hours=3)).day <= current_date.day) and i < 10:
        r = requests.get(f"https://{domain[0]}/page/{i}").text
        soup = BeautifulSoup(r, "html.parser")
        
        for game in soup.select("tr"):
            try:
                if "date" in game.attrs["class"]: continue
                game_title = game.select_one("a.summary").text
                game_time = datetime(*(time.strptime(game.select_one("span.value-title").get("title"), "%Y-%m-%dT%H:%M+00:00")[:6]))
                league = game.select_one("td.type").select_one("img").get("alt")
                game_id = game.get("id")
                game_icon = "https:" + game.select_one("td.type").select_one("img").get("src")
                game_description = game.select_one("a.description").text.strip()
                try: teams = [re.findall(r"List (.+?) events", team.get("title"))[0] for team in game.select("a.team")]
                except: teams = []
                games.append({
                    "title": game_title,
                    "links": [
                        f"https://freefeds.com/stream/{game_id}.html",
                        f"https://freefeds.com/stream/2/{game_id}.html",
                        f"https://freefeds.com/stream/3/{game_id}.html"
                    ],
                    "icon": game_icon,
                    "league": f"{league} ({game_description})",
                    "time": game_time,
                    "teams": teams
                })
            except:
                continue
        if len(games) == 0: break
        i += 1
    return games
